package start6_1;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

// Some code copied from an example with this comment-block
       /*
        * Copyright (c) 1995, 2008, Oracle and/or its affiliates. All rights reserved.
        *
        * Redistribution and use in source and binary forms, with or without
        * modification, are permitted provided that the following conditions
        * are met:
        *
        *   - Redistributions of source code must retain the above copyright
        *     notice, this list of conditions and the following disclaimer.
        *
        *   - Redistributions in binary form must reproduce the above copyright
        *     notice, this list of conditions and the following disclaimer in the
        *     documentation and/or other materials provided with the distribution.
        *
        *   - Neither the name of Oracle or the names of its
        *     contributors may be used to endorse or promote products derived
        *     from this software without specific prior written permission.
        *
        * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
        * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
        * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
        * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
        * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
        * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
        * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
        * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
        * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
        * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
        * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
        */

public class InvokeLaterExample extends JPanel {
    private JButton button = new JButton("Please push me!");

    public static void logLocation(String label) {
        System.out.println(label+ ".");
    }

    public InvokeLaterExample() {
        logLocation("ex start");

        ActionListener buttonListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent evt) {
                button.setText("You pushed me!");
                logLocation("bl");
            }
        };
        button.addActionListener(buttonListener);
        add(button);

        logLocation("ex end");
    }

    public static void createAndShowGUI() {
        logLocation("casg start");

        // Create window
        JFrame frame = new JFrame("Example");
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        // Create the content pane (this example)
        InvokeLaterExample example = new InvokeLaterExample();
        frame.setContentPane(example);

        // Display the window.
        frame.pack();
        frame.setVisible(true);
        logLocation("casg end");
    }

    public static void main(String[] ignored) {
        logLocation("main start");
        createAndShowGUI();
        logLocation("main end");
    }
}
